<template>
  <v-card class="elevation-12">
      <v-form>
          <v-card-title>Créez un compte</v-card-title>
          <v-card-text>
            <v-text-field  
              v-model="email" 
              type="email"
              placeholder="Votre email*"
              id="email"
              autocomplete="username"
              :error-messages="emailErrors"
            />
          </v-card-text>
          <v-card-text>
            <v-text-field  
              v-model="firstName" 
              type="text"
              placeholder="Prénom*"
              id="Firstname"
              :error-messages="firstNameErrors"
            />
          </v-card-text>
          <v-card-text>
            <v-text-field  
              v-model="lastName" 
              type="text"
              placeholder="Nom de famille*"
              id="Lastname"
              :error-messages="lastNameErrors"
            />
          </v-card-text>
          <v-card-text>
            <v-text-field  
              v-model="password" 
              type="password"
              placeholder="Mot de passe*"
              id="password"
              autocomplete="new-password"
              :error-messages="passErrors"
            />
          </v-card-text>
          <v-card-text>
            <v-text-field  
              v-model="confirmPass"
              type="password"
              placeholder="Confirmation de mot de passe*"
              id="confirmPassword"
              :error-messages="confirmPassErrors"
            />
          </v-card-text>
          <v-card-actions>
            <v-btn color="secondary" light type="submit" @click="register">
              S'inscrire
            </v-btn>
          </v-card-actions>
      </v-form>
      <v-card-text>
        <span>Déjà inscrit ? </span> 
        <router-link :to="{ name: 'login' }" style="text-decoration: none;">
          <b>Connectez vous ici</b>
        </router-link>
      </v-card-text>
  </v-card>
</template>

<script>
import { validationMixin } from 'vuelidate';
import { required, email, sameAs, minLength } from 'vuelidate/lib/validators';
export default {
  mixins: [validationMixin],
  validations: {
    lastName: {required},
		firstName: { required },
		email: { required, email },
		password : {required, minLength: minLength(6)},
		confirmPass : {required, sameAsPassword: sameAs('password')}
	},
  data() {
    return {
      email: '',
      firstName: '',
      lastName:'',
      password:'',
      confirmPass: '',
      errors: [],
    }
  },
  computed: {
		lastNameErrors () {
			const errors = []
			if (!this.$v.lastName.$dirty) return errors
			!this.$v.lastName.required && errors.push('lastName requis')
			return errors
		},
		firstNameErrors () {
			const errors = []
			if (!this.$v.firstName.$dirty) return errors
			!this.$v.firstName.required && errors.push('firstName requis')
			return errors
		},

		emailErrors () {
			const errors = []
			if (!this.$v.email.$dirty) return errors
			!this.$v.email.email && errors.push('Email non valide')
			!this.$v.email.required && errors.push('Email requis')
			return errors
		},
		passErrors () {
			const errors = []
			if (!this.$v.password.$dirty) return errors
			!this.$v.password.minLength && errors.push('Mot de passe trop court')
			!this.$v.password.required && errors.push('Mot de passe requis')
			return errors
		},
		confirmPassErrors () {
			const errors = []
			if (!this.$v.confirmPass.$dirty) return errors
			!this.$v.confirmPass.sameAsPassword && errors.push('Les mots de passes ne correspondent pas')
			!this.$v.confirmPass.required && errors.push('Confirmation de mot de passe requise')
			return errors
		},
	},
  methods: {
    register: function (event) {
      event.preventDefault();
      this.$v.$touch();
      if (this.$v.$invalid) {
        return false;
      }
      let user = {
        email : this.email,
        firstName: this.firstName,
        lastName : this.lastName,
        password : this.password
      }
      this.$emit('registered', user);

    }
    
  }
}
</script>

<style>
</style>